package com.faraphel.tasks_valider.ui.widgets.tasks

import androidx.compose.foundation.layout.Arrangement
import androidx.compose.foundation.layout.Column
import androidx.compose.foundation.layout.Row
import androidx.compose.foundation.layout.Spacer
import androidx.compose.foundation.layout.fillMaxSize
import androidx.compose.foundation.layout.width
import androidx.compose.material3.Checkbox
import androidx.compose.material3.Text
import androidx.compose.runtime.Composable
import androidx.compose.ui.Modifier
import androidx.compose.ui.unit.dp
import com.faraphel.tasks_valider.database.Database
import com.faraphel.tasks_valider.database.entities.TaskGroup


@Composable
fun WidgetTaskStudent(database: Database, taskStudent: TaskGroup) {
    val teacherDao = database.teacherDao()

    Column {
        // row for this task
        Row {
            // task information
            // TODO: WidgetTask(task = taskStudent.task)

            // align the other columns to the right
            Spacer(modifier = Modifier.weight(1f))

            // task status
            Checkbox(
                checked = taskStudent.approvalStatus,
                onCheckedChange = { status -> taskStudent.approvalStatus = status }
            )
        }

        // if the task has been approved
        if (taskStudent.approvalStatus) {
            Row (
                modifier = Modifier.fillMaxSize(),
                horizontalArrangement = Arrangement.Center
            ) {
                // teacher who approved the task
                Text(text = teacherDao.getById(taskStudent.approvalTeacherId!!).fullName)

                // align the other columns to the right
                Spacer(modifier = Modifier.width(16.dp))

                // date of approval
                Text(text = taskStudent.approvalTime.toString())
            }
        }
    }
}
